/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.34 from the
 * contents of HandlerSocket.xs. Do not edit this file, edit HandlerSocket.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "HandlerSocket.xs"

// vim:ai:sw=2:ts=8

/*
 * Copyright (C) 2010 DeNA Co.,Ltd.. All rights reserved.
 * See COPYRIGHT.txt for details.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "hstcpcli.hpp"

#define DBG(x)

static SV *
arr_get_entry(AV *av, I32 avmax, I32 idx)
{
  if (idx > avmax) {
    DBG(fprintf(stderr, "arr_get_entry1 %d %d\n", avmax, idx));
    return 0;
  }
  SV **const ev = av_fetch(av, idx, 0);
  if (ev == 0) {
    DBG(fprintf(stderr, "arr_get_entry2 %d %d\n", avmax, idx));
    return 0;
  }
  return *ev;
}

static int
arr_get_intval(AV *av, I32 avmax, I32 idx, int default_val = 0)
{
  SV *const e = arr_get_entry(av, avmax, idx);
  if (e == 0) {
    return default_val;
  }
  return SvIV(e);
}

static const char *
sv_get_strval(SV *sv)
{
  if (sv == 0 || !SvPOK(sv)) {
    DBG(fprintf(stderr, "sv_get_strval\n"));
    return 0;
  }
  return SvPV_nolen(sv);
}

static const char *
arr_get_strval(AV *av, I32 avmax, I32 idx)
{
  SV *const e = arr_get_entry(av, avmax, idx);
  return sv_get_strval(e);
}

static AV *
sv_get_arrval(SV *sv)
{
  if (sv == 0 || !SvROK(sv)) {
    DBG(fprintf(stderr, "sv_get_arrval1\n"));
    return 0;
  }
  SV *const svtarget = SvRV(sv);
  if (svtarget == 0 || SvTYPE(svtarget) != SVt_PVAV) {
    DBG(fprintf(stderr, "sv_get_arrval2\n"));
    return 0;
  }
  return (AV *)svtarget;
}

static AV *
arr_get_arrval(AV *av, I32 avmax, I32 idx)
{
  SV *const e = arr_get_entry(av, avmax, idx);
  if (e == 0) {
    DBG(fprintf(stderr, "arr_get_arrval1\n"));
    return 0;
  }
  return sv_get_arrval(e);
}

static void
hv_to_strmap(HV *hv, std::map<std::string, std::string>& m_r)
{
  if (hv == 0) {
    return;
  }
  hv_iterinit(hv);
  HE *hent = 0;
  while ((hent = hv_iternext(hv)) != 0) {
    I32 klen = 0;
    char *const k = hv_iterkey(hent, &klen);
    DBG(fprintf(stderr, "k=%s\n", k));
    const std::string key(k, klen);
    SV *const vsv = hv_iterval(hv, hent);
    STRLEN vlen = 0;
    char *const v = SvPV(vsv, vlen);
    DBG(fprintf(stderr, "v=%s\n", v));
    const std::string val(v, vlen);
    m_r[key] = val;
  }
}

static void
strrefarr_push_back(std::vector<dena::string_ref>& a_r, SV *sv)
{
  if (sv == 0 || SvTYPE(sv) == SVt_NULL) { /* !SvPOK()? */
    DBG(fprintf(stderr, "strrefarr_push_back: null\n"));
    return a_r.push_back(dena::string_ref());
  }
  STRLEN vlen = 0;
  char *const v = SvPV(sv, vlen);
  DBG(fprintf(stderr, "strrefarr_push_back: %s\n", v));
  a_r.push_back(dena::string_ref(v, vlen));
}

static void
av_to_strrefarr(AV *av, std::vector<dena::string_ref>& a_r)
{
  if (av == 0) {
    return;
  }
  const I32 len = av_len(av) + 1;
  for (I32 i = 0; i < len; ++i) {
    SV **const ev = av_fetch(av, i, 0);
    strrefarr_push_back(a_r, ev ? *ev : 0);
  }
}

static dena::string_ref
sv_get_string_ref(SV *sv)
{
  if (sv == 0 || SvTYPE(sv) == SVt_NULL) { /* !SvPOK()? */
    return dena::string_ref();
  }
  STRLEN vlen = 0;
  char *const v = SvPV(sv, vlen);
  return dena::string_ref(v, vlen);
}

static IV
sv_get_iv(SV *sv)
{
  if (sv == 0 || ( !SvIOK(sv) && !SvPOK(sv) ) ) {
    return 0;
  }
  return SvIV(sv);
}

static void
av_to_filters(AV *av, std::vector<dena::hstcpcli_filter>& f_r)
{
  DBG(fprintf(stderr, "av_to_filters: %p\n", av));
  if (av == 0) {
    return;
  }
  const I32 len = av_len(av) + 1;
  DBG(fprintf(stderr, "av_to_filters: len=%d\n", (int)len));
  for (I32 i = 0; i < len; ++i) {
    AV *const earr = arr_get_arrval(av, len, i);
    if (earr == 0) {
      continue;
    }
    const I32 earrlen = av_len(earr) + 1;
    dena::hstcpcli_filter fe;
    fe.filter_type = sv_get_string_ref(arr_get_entry(earr, earrlen, 0));
    fe.op = sv_get_string_ref(arr_get_entry(earr, earrlen, 1));
    fe.ff_offset = sv_get_iv(arr_get_entry(earr, earrlen, 2));
    fe.val = sv_get_string_ref(arr_get_entry(earr, earrlen, 3));
    f_r.push_back(fe);
    DBG(fprintf(stderr, "av_to_filters: %s %s %d %s\n",
      fe.filter_action.begin(), fe.filter_op.begin(), (int)fe.ff_offset,
      fe.value.begin()));
  }
}

static void
set_process_verbose_level(const std::map<std::string, std::string>& m)
{
  std::map<std::string, std::string>::const_iterator iter = m.find("verbose");
  if (iter != m.end()) {
    dena::verbose_level = atoi(iter->second.c_str());
  }
}

static AV *
execute_internal(SV *obj, int id, const char *op, AV *keys, int limit,
  int skip, const char *modop, AV *modvals, AV *filters, int invalues_keypart,
  AV *invalues)
{
  AV *retval = (AV *)&PL_sv_undef;
  dena::hstcpcli_i *const ptr =
    reinterpret_cast<dena::hstcpcli_i *>(SvIV(SvRV(obj)));
  do {
    std::vector<dena::string_ref> keyarr, mvarr;
    std::vector<dena::hstcpcli_filter> farr;
    std::vector<dena::string_ref> ivs;
    av_to_strrefarr(keys, keyarr);
    dena::string_ref modop_ref;
    if (modop != 0) {
      modop_ref = dena::string_ref(modop, strlen(modop));
      av_to_strrefarr(modvals, mvarr);
    }
    if (filters != 0) {
      av_to_filters(filters, farr);
    }
    if (invalues_keypart >= 0 && invalues != 0) {
      av_to_strrefarr(invalues, ivs);
    }
    ptr->request_buf_exec_generic(id, dena::string_ref(op, strlen(op)),
      &keyarr[0], keyarr.size(), limit, skip, modop_ref, &mvarr[0],
      mvarr.size(), &farr[0], farr.size(), invalues_keypart, &ivs[0],
      ivs.size());
    AV *const av = newAV();
    retval = av;
    if (ptr->request_send() != 0) {
      break;
    }
    size_t nflds = 0;
    ptr->response_recv(nflds);
    const int e = ptr->get_error_code();
    DBG(fprintf(stderr, "e=%d nflds=%zu\n", e, nflds));
    av_push(av, newSViv(e));
    if (e != 0) {
      const std::string s = ptr->get_error();
      av_push(av, newSVpvn(s.data(), s.size()));
    } else {
      const dena::string_ref *row = 0;
      while ((row = ptr->get_next_row()) != 0) {
	DBG(fprintf(stderr, "row=%p\n", row));
	for (size_t i = 0; i < nflds; ++i) {
	  const dena::string_ref& v = row[i];
	  DBG(fprintf(stderr, "FLD %zu v=%s vbegin=%p\n", i,
	    std::string(v.begin(), v.size())
	      .c_str(), v.begin()));
	  if (v.begin() != 0) {
	    SV *const e = newSVpvn(
	      v.begin(), v.size());
	    av_push(av, e);
	  } else {
	    av_push(av, &PL_sv_undef);
	  }
	}
      }
    }
    if (e >= 0) {
      ptr->response_buf_remove();
    }
  } while (0);
  return retval;
}

struct execute_arg {
  int id;
  const char *op;
  AV *keys;
  int limit;
  int skip;
  const char *modop;
  AV *modvals;
  AV *filters;
  int invalues_keypart;
  AV *invalues;
  execute_arg() : id(0), op(0), keys(0), limit(0), skip(0), modop(0),
    modvals(0), filters(0), invalues_keypart(-1), invalues(0) { }
};

static AV *
execute_multi_internal(SV *obj, const execute_arg *args, size_t num_args)
{
  dena::hstcpcli_i *const ptr =
    reinterpret_cast<dena::hstcpcli_i *>(SvIV(SvRV(obj)));
  /* appends multiple requests to the send buffer */
  for (size_t i = 0; i < num_args; ++i) {
    std::vector<dena::string_ref> keyarr, mvarr;
    std::vector<dena::hstcpcli_filter> farr;
    std::vector<dena::string_ref> ivs;
    const execute_arg& arg = args[i];
    av_to_strrefarr(arg.keys, keyarr);
    dena::string_ref modop_ref;
    if (arg.modop != 0) {
      modop_ref = dena::string_ref(arg.modop, strlen(arg.modop));
      av_to_strrefarr(arg.modvals, mvarr);
    }
    if (arg.filters != 0) {
      av_to_filters(arg.filters, farr);
    }
    if (arg.invalues_keypart >= 0 && arg.invalues != 0) {
      av_to_strrefarr(arg.invalues, ivs);
    }
    ptr->request_buf_exec_generic(arg.id,
      dena::string_ref(arg.op, strlen(arg.op)), &keyarr[0], keyarr.size(),
      arg.limit, arg.skip, modop_ref, &mvarr[0], mvarr.size(), &farr[0],
      farr.size(), arg.invalues_keypart, &ivs[0], ivs.size());
  }
  AV *const retval = newAV();
  /* sends the requests */
  if (ptr->request_send() < 0) {
    /* IO error */
    AV *const av_respent = newAV();
    av_push(retval, newRV_noinc((SV *)av_respent));
    av_push(av_respent, newSViv(ptr->get_error_code()));
    const std::string& s = ptr->get_error();
    av_push(av_respent, newSVpvn(s.data(), s.size()));
    return retval; /* retval : [ [ err_code, err_message ] ] */
  }
  /* receives responses */
  for (size_t i = 0; i < num_args; ++i) {
    AV *const av_respent = newAV();
    av_push(retval, newRV_noinc((SV *)av_respent));
    size_t nflds = 0;
    const int e = ptr->response_recv(nflds);
    av_push(av_respent, newSViv(e));
    if (e != 0) {
      const std::string& s = ptr->get_error();
      av_push(av_respent, newSVpvn(s.data(), s.size()));
    } else {
      const dena::string_ref *row = 0;
      while ((row = ptr->get_next_row()) != 0) {
	for (size_t i = 0; i < nflds; ++i) {
	  const dena::string_ref& v = row[i];
	  DBG(fprintf(stderr, "%zu %s\n", i,
	    std::string(v.begin(), v.size()).c_str()));
	  if (v.begin() != 0) {
	    av_push(av_respent, newSVpvn(v.begin(), v.size()));
	  } else {
	    /* null */
	    av_push(av_respent, &PL_sv_undef);
	  }
	}
      }
    }
    if (e >= 0) {
      ptr->response_buf_remove();
    }
    if (e < 0) {
      return retval;
    }
  }
  return retval;
}

#line 358 "HandlerSocket.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 502 "HandlerSocket.c"

XS_EUPXS(XS_Net__HandlerSocket_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "klass, args");
    {
	char *	klass = (char *)SvPV_nolen(ST(0))
;
	HV *	args;
	SV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    args = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::HandlerSocket::new",
				"args");
		}
	} STMT_END
;
#line 355 "HandlerSocket.xs"
  RETVAL = &PL_sv_undef;
  dena::config conf;
  hv_to_strmap(args, conf);
  set_process_verbose_level(conf);
  dena::socket_args sargs;
  sargs.set(conf);
  dena::hstcpcli_ptr p = dena::hstcpcli_i::create(sargs);
  SV *const objref = newSViv(0);
  SV *const obj = newSVrv(objref, klass);
  dena::hstcpcli_i *const ptr = p.get();
  sv_setiv(obj, reinterpret_cast<IV>(ptr));
  p.release();
  SvREADONLY_on(obj);
  RETVAL = objref;
#line 544 "HandlerSocket.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__HandlerSocket_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV *	obj = ST(0)
;
#line 376 "HandlerSocket.xs"
  dena::hstcpcli_i *const ptr =
    reinterpret_cast<dena::hstcpcli_i *>(SvIV(SvRV(obj)));
  delete ptr;
#line 565 "HandlerSocket.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__HandlerSocket_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV *	obj = ST(0)
;
#line 384 "HandlerSocket.xs"
  dena::hstcpcli_i *const ptr =
    reinterpret_cast<dena::hstcpcli_i *>(SvIV(SvRV(obj)));
  ptr->close();
#line 584 "HandlerSocket.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__HandlerSocket_reconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_reconnect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV *	obj = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 392 "HandlerSocket.xs"
  RETVAL = 0;
  dena::hstcpcli_i *const ptr =
    reinterpret_cast<dena::hstcpcli_i *>(SvIV(SvRV(obj)));
  RETVAL = ptr->reconnect();
#line 606 "HandlerSocket.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__HandlerSocket_stable_point); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_stable_point)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV *	obj = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 403 "HandlerSocket.xs"
  RETVAL = 0;
  dena::hstcpcli_i *const ptr =
    reinterpret_cast<dena::hstcpcli_i *>(SvIV(SvRV(obj)));
  const bool rv = ptr->stable_point();
  RETVAL = static_cast<int>(rv);
#line 630 "HandlerSocket.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__HandlerSocket_get_error_code); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_get_error_code)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV *	obj = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 415 "HandlerSocket.xs"
  RETVAL = 0;
  dena::hstcpcli_i *const ptr =
    reinterpret_cast<dena::hstcpcli_i *>(SvIV(SvRV(obj)));
  RETVAL = ptr->get_error_code();
#line 653 "HandlerSocket.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__HandlerSocket_get_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_get_error)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV *	obj = ST(0)
;
	SV *	RETVAL;
#line 426 "HandlerSocket.xs"
  RETVAL = &PL_sv_undef;
  dena::hstcpcli_i *const ptr =
    reinterpret_cast<dena::hstcpcli_i *>(SvIV(SvRV(obj)));
  const std::string s = ptr->get_error();
  RETVAL = newSVpvn(s.data(), s.size());
#line 676 "HandlerSocket.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__HandlerSocket_auth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_auth)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "obj, key, typ = 0");
    {
	SV *	obj = ST(0)
;
	const char *	key = (const char *)SvPV_nolen(ST(1))
;
	const char *	typ;
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    typ = 0;
	else {
	    typ = (const char *)SvPV_nolen(ST(2))
;
	}
#line 440 "HandlerSocket.xs"
  RETVAL = 0;
  dena::hstcpcli_i *const ptr =
    reinterpret_cast<dena::hstcpcli_i *>(SvIV(SvRV(obj)));
  do {
    ptr->request_buf_auth(key, typ);
    if (ptr->request_send() != 0) {
      break;
    }
    size_t nflds = 0;
    ptr->response_recv(nflds);
    const int e = ptr->get_error_code();
    DBG(fprintf(stderr, "errcode=%d\n", ptr->get_error_code()));
    if (e >= 0) {
      ptr->response_buf_remove();
    }
    DBG(fprintf(stderr, "errcode=%d\n", ptr->get_error_code()));
  } while (0);
  RETVAL = ptr->get_error_code();
#line 724 "HandlerSocket.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__HandlerSocket_open_index); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_open_index)
{
    dVAR; dXSARGS;
    if (items < 6 || items > 7)
       croak_xs_usage(cv,  "obj, id, db, table, index, fields, ffields = 0");
    {
	SV *	obj = ST(0)
;
	int	id = (int)SvIV(ST(1))
;
	const char *	db = (const char *)SvPV_nolen(ST(2))
;
	const char *	table = (const char *)SvPV_nolen(ST(3))
;
	const char *	index = (const char *)SvPV_nolen(ST(4))
;
	const char *	fields = (const char *)SvPV_nolen(ST(5))
;
	SV *	ffields;
	int	RETVAL;
	dXSTARG;

	if (items < 7)
	    ffields = 0;
	else {
	    ffields = ST(6)
;
	}
#line 472 "HandlerSocket.xs"
  const char *const ffields_str = sv_get_strval(ffields);
  RETVAL = 0;
  dena::hstcpcli_i *const ptr =
    reinterpret_cast<dena::hstcpcli_i *>(SvIV(SvRV(obj)));
  do {
    ptr->request_buf_open_index(id, db, table, index, fields, ffields_str);
    if (ptr->request_send() != 0) {
      break;
    }
    size_t nflds = 0;
    ptr->response_recv(nflds);
    const int e = ptr->get_error_code();
    DBG(fprintf(stderr, "errcode=%d\n", ptr->get_error_code()));
    if (e >= 0) {
      ptr->response_buf_remove();
    }
    DBG(fprintf(stderr, "errcode=%d\n", ptr->get_error_code()));
  } while (0);
  RETVAL = ptr->get_error_code();
#line 780 "HandlerSocket.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__HandlerSocket_execute_single); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_execute_single)
{
    dVAR; dXSARGS;
    if (items < 6 || items > 11)
       croak_xs_usage(cv,  "obj, id, op, keys, limit, skip, mop = 0, mvs = 0, fils = 0, ivkeypart = -1, ivs = 0");
    {
	SV *	obj = ST(0)
;
	int	id = (int)SvIV(ST(1))
;
	const char *	op = (const char *)SvPV_nolen(ST(2))
;
	AV *	keys;
	int	limit = (int)SvIV(ST(4))
;
	int	skip = (int)SvIV(ST(5))
;
	SV *	mop;
	SV *	mvs;
	SV *	fils;
	int	ivkeypart;
	SV *	ivs;
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(3);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    keys = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Net::HandlerSocket::execute_single",
				"keys");
		}
	} STMT_END
;

	if (items < 7)
	    mop = 0;
	else {
	    mop = ST(6)
;
	}

	if (items < 8)
	    mvs = 0;
	else {
	    mvs = ST(7)
;
	}

	if (items < 9)
	    fils = 0;
	else {
	    fils = ST(8)
;
	}

	if (items < 10)
	    ivkeypart = -1;
	else {
	    ivkeypart = (int)SvIV(ST(9))
;
	}

	if (items < 11)
	    ivs = 0;
	else {
	    ivs = ST(10)
;
	}
#line 508 "HandlerSocket.xs"
  const char *const mop_str = sv_get_strval(mop);
  AV *const mvs_av = sv_get_arrval(mvs);
  AV *const fils_av = sv_get_arrval(fils);
  AV *const ivs_av = sv_get_arrval(ivs);
  RETVAL = execute_internal(obj, id, op, keys, limit, skip, mop_str, mvs_av,
    fils_av, ivkeypart, ivs_av);
  sv_2mortal((SV *)RETVAL);
#line 868 "HandlerSocket.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__HandlerSocket_execute_multi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_execute_multi)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "obj, cmds");
    {
	SV *	obj = ST(0)
;
	AV *	cmds;
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    cmds = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Net::HandlerSocket::execute_multi",
				"cmds");
		}
	} STMT_END
;
#line 523 "HandlerSocket.xs"
  DBG(fprintf(stderr, "execute_multi0\n"));
  const I32 cmdsmax = av_len(cmds);
  execute_arg args[cmdsmax + 1]; /* GNU */
  for (I32 i = 0; i <= cmdsmax; ++i) {
    AV *const avtarget = arr_get_arrval(cmds, cmdsmax, i);
    if (avtarget == 0) {
      DBG(fprintf(stderr, "execute_multi1 %d\n", i));
      continue;
    }
    const I32 argmax = av_len(avtarget);
    if (argmax < 2) {
      DBG(fprintf(stderr, "execute_multi2 %d\n", i));
      continue;
    }
    execute_arg& ag = args[i];
    ag.id = arr_get_intval(avtarget, argmax, 0);
    ag.op = arr_get_strval(avtarget, argmax, 1);
    ag.keys = arr_get_arrval(avtarget, argmax, 2);
    ag.limit = arr_get_intval(avtarget, argmax, 3);
    ag.skip = arr_get_intval(avtarget, argmax, 4);
    ag.modop = arr_get_strval(avtarget, argmax, 5);
    ag.modvals = arr_get_arrval(avtarget, argmax, 6);
    ag.filters = arr_get_arrval(avtarget, argmax, 7);
    ag.invalues_keypart = arr_get_intval(avtarget, argmax, 8, -1);
    ag.invalues = arr_get_arrval(avtarget, argmax, 9);
    DBG(fprintf(stderr, "execute_multi3 %d: %d %s %p %d %d %s %p %p %d %p\n",
      i, ag.id, ag.op, ag.keys, ag.limit, ag.skip, ag.modop, ag.modvals,
      ag.filters, ag.invalues_keypart, ag.invalues));
  }
  RETVAL = execute_multi_internal(obj, args, cmdsmax + 1);
  sv_2mortal((SV *)RETVAL);
#line 937 "HandlerSocket.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__HandlerSocket_execute_find); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_execute_find)
{
    dVAR; dXSARGS;
    if (items < 6 || items > 11)
       croak_xs_usage(cv,  "obj, id, op, keys, limit, skip, mop = 0, mvs = 0, fils = 0, ivkeypart = -1, ivs = 0");
    {
	SV *	obj = ST(0)
;
	int	id = (int)SvIV(ST(1))
;
	const char *	op = (const char *)SvPV_nolen(ST(2))
;
	AV *	keys;
	int	limit = (int)SvIV(ST(4))
;
	int	skip = (int)SvIV(ST(5))
;
	SV *	mop;
	SV *	mvs;
	SV *	fils;
	int	ivkeypart;
	SV *	ivs;
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(3);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    keys = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Net::HandlerSocket::execute_find",
				"keys");
		}
	} STMT_END
;

	if (items < 7)
	    mop = 0;
	else {
	    mop = ST(6)
;
	}

	if (items < 8)
	    mvs = 0;
	else {
	    mvs = ST(7)
;
	}

	if (items < 9)
	    fils = 0;
	else {
	    fils = ST(8)
;
	}

	if (items < 10)
	    ivkeypart = -1;
	else {
	    ivkeypart = (int)SvIV(ST(9))
;
	}

	if (items < 11)
	    ivs = 0;
	else {
	    ivs = ST(10)
;
	}
#line 571 "HandlerSocket.xs"
  const char *const mop_str = sv_get_strval(mop);
  AV *const mvs_av = sv_get_arrval(mvs);
  AV *const fils_av = sv_get_arrval(fils);
  AV *const ivs_av = sv_get_arrval(ivs);
  RETVAL = execute_internal(obj, id, op, keys, limit, skip, mop_str, mvs_av,
    fils_av, ivkeypart, ivs_av);
  sv_2mortal((SV *)RETVAL);
#line 1030 "HandlerSocket.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__HandlerSocket_execute_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_execute_update)
{
    dVAR; dXSARGS;
    if (items < 7 || items > 10)
       croak_xs_usage(cv,  "obj, id, op, keys, limit, skip, modvals, fils = 0, ivkeypart = -1, ivs = 0");
    {
	SV *	obj = ST(0)
;
	int	id = (int)SvIV(ST(1))
;
	const char *	op = (const char *)SvPV_nolen(ST(2))
;
	AV *	keys;
	int	limit = (int)SvIV(ST(4))
;
	int	skip = (int)SvIV(ST(5))
;
	AV *	modvals;
	SV *	fils;
	int	ivkeypart;
	SV *	ivs;
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(3);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    keys = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Net::HandlerSocket::execute_update",
				"keys");
		}
	} STMT_END
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(6);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    modvals = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Net::HandlerSocket::execute_update",
				"modvals");
		}
	} STMT_END
;

	if (items < 8)
	    fils = 0;
	else {
	    fils = ST(7)
;
	}

	if (items < 9)
	    ivkeypart = -1;
	else {
	    ivkeypart = (int)SvIV(ST(8))
;
	}

	if (items < 10)
	    ivs = 0;
	else {
	    ivs = ST(9)
;
	}
#line 594 "HandlerSocket.xs"
  AV *const fils_av = sv_get_arrval(fils);
  AV *const ivs_av = sv_get_arrval(ivs);
  RETVAL = execute_internal(obj, id, op, keys, limit, skip, "U",
    modvals, fils_av, ivkeypart, ivs_av);
  sv_2mortal((SV *)RETVAL);
#line 1120 "HandlerSocket.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__HandlerSocket_execute_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_execute_delete)
{
    dVAR; dXSARGS;
    if (items < 6 || items > 9)
       croak_xs_usage(cv,  "obj, id, op, keys, limit, skip, fils = 0, ivkeypart = -1, ivs = 0");
    {
	SV *	obj = ST(0)
;
	int	id = (int)SvIV(ST(1))
;
	const char *	op = (const char *)SvPV_nolen(ST(2))
;
	AV *	keys;
	int	limit = (int)SvIV(ST(4))
;
	int	skip = (int)SvIV(ST(5))
;
	SV *	fils;
	int	ivkeypart;
	SV *	ivs;
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(3);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    keys = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Net::HandlerSocket::execute_delete",
				"keys");
		}
	} STMT_END
;

	if (items < 7)
	    fils = 0;
	else {
	    fils = ST(6)
;
	}

	if (items < 8)
	    ivkeypart = -1;
	else {
	    ivkeypart = (int)SvIV(ST(7))
;
	}

	if (items < 9)
	    ivs = 0;
	else {
	    ivs = ST(8)
;
	}
#line 614 "HandlerSocket.xs"
  AV *const fils_av = sv_get_arrval(fils);
  AV *const ivs_av = sv_get_arrval(ivs);
  RETVAL = execute_internal(obj, id, op, keys, limit, skip, "D", 0, fils_av,
    ivkeypart, ivs_av);
  sv_2mortal((SV *)RETVAL);
#line 1195 "HandlerSocket.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__HandlerSocket_execute_insert); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__HandlerSocket_execute_insert)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "obj, id, fvals");
    {
	SV *	obj = ST(0)
;
	int	id = (int)SvIV(ST(1))
;
	AV *	fvals;
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    fvals = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Net::HandlerSocket::execute_insert",
				"fvals");
		}
	} STMT_END
;
#line 628 "HandlerSocket.xs"
  RETVAL = execute_internal(obj, id, "+", fvals, 0, 0, 0, 0, 0, -1, 0);
  sv_2mortal((SV *)RETVAL);
#line 1237 "HandlerSocket.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Net__HandlerSocket); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__HandlerSocket)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Net::HandlerSocket::new", XS_Net__HandlerSocket_new);
        newXS_deffile("Net::HandlerSocket::DESTROY", XS_Net__HandlerSocket_DESTROY);
        newXS_deffile("Net::HandlerSocket::close", XS_Net__HandlerSocket_close);
        newXS_deffile("Net::HandlerSocket::reconnect", XS_Net__HandlerSocket_reconnect);
        newXS_deffile("Net::HandlerSocket::stable_point", XS_Net__HandlerSocket_stable_point);
        newXS_deffile("Net::HandlerSocket::get_error_code", XS_Net__HandlerSocket_get_error_code);
        newXS_deffile("Net::HandlerSocket::get_error", XS_Net__HandlerSocket_get_error);
        newXS_deffile("Net::HandlerSocket::auth", XS_Net__HandlerSocket_auth);
        newXS_deffile("Net::HandlerSocket::open_index", XS_Net__HandlerSocket_open_index);
        newXS_deffile("Net::HandlerSocket::execute_single", XS_Net__HandlerSocket_execute_single);
        newXS_deffile("Net::HandlerSocket::execute_multi", XS_Net__HandlerSocket_execute_multi);
        newXS_deffile("Net::HandlerSocket::execute_find", XS_Net__HandlerSocket_execute_find);
        newXS_deffile("Net::HandlerSocket::execute_update", XS_Net__HandlerSocket_execute_update);
        newXS_deffile("Net::HandlerSocket::execute_delete", XS_Net__HandlerSocket_execute_delete);
        newXS_deffile("Net::HandlerSocket::execute_insert", XS_Net__HandlerSocket_execute_insert);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

